#include <Trade\Trade.mqh>

CTrade trade;

void OnTick() {
   
   //=======================================================================================================================
   //================================== GERNERLL ===========================================================================
   //Preis Array
   MqlRates PriceInfo[];
   
   //Array von der aktuellen Kerze abwärts sortieren
   ArraySetAsSeries(PriceInfo, true);
   
   //Array mit Preisdaten füllen
   int Data = CopyRates(Symbol(), Period(), 0, 20, PriceInfo);
   
   //Variable für das Signal
   string signal = "";
   //=======================================================================================================================
   
   //=======================================================================================================================
   //================================== BOLLINGER BANDS ====================================================================
   //Array für jedes BollingerBand
   double MiddleBandArray[];
   double UpperBandArray[];
   double LowerBandArray[];
   
   //Sortiere Preise für jedes Band abwärts
   ArraySetAsSeries(MiddleBandArray, true);
   ArraySetAsSeries(UpperBandArray, true);
   ArraySetAsSeries(LowerBandArray, true);
   
   //Definition BollingerBands
   int BollingerBandsDefinition = iBands(_Symbol, _Period, 20, 0, 2, PRICE_CLOSE);
   
   //Kopiere die Daten ins Band Array für 3 Kerzen
   CopyBuffer(BollingerBandsDefinition, 0, 0, 3, MiddleBandArray);
   CopyBuffer(BollingerBandsDefinition, 1, 0, 3, UpperBandArray);
   CopyBuffer(BollingerBandsDefinition, 2, 0, 3, LowerBandArray);
   
   //Berechne Wert für Kerze 0
   double MiddleBand0 = MiddleBandArray[0];
   double UpperBand0 = UpperBandArray[0];
   double LowerBand0 = LowerBandArray[0];
   
   //Berechne Wert für Kerze 1
   double MiddleBand1 = MiddleBandArray[1];
   double UpperBand1 = UpperBandArray[1];
   double LowerBand1 = LowerBandArray[1];
   //=======================================================================================================================
   
   //=======================================================================================================================
   //================================== MACD ===============================================================================
   //Array für verschiedene Preise
   double MACDPriceArray[];
   
   //Definiere Eigenschaften von MacD EA
   int MacDDefinition = iMACD(_Symbol, _Period, 11, 27, 4, PRICE_CLOSE);
   
   //Definiere MA1, ein Buffer, aktuelle Kerze, 3 Kerzen, Speicherergebnis
   CopyBuffer(MacDDefinition, 0, 0, 3, MACDPriceArray);
   
   //Wert der aktuellen Kerze
   float MacDValue = (MACDPriceArray[1]);
   //=======================================================================================================================
   
   //=======================================================================================================================
   //================================== GEGLÄTTETER GLEITENDER DURCHSCHNITT ================================================
   //ARRAY FÜR DEN SMMA
   double SMMAArray[];
   
   //DEFINITION FÜR DEN MOVING AVERAGE
   int movingAverageDefinition = iMA(_Symbol,_Period,2,0,MODE_SMA,PRICE_CLOSE);
   
   // DEFINIERE EDA, EINE LINIE, VON KERZE 0, FÜR 3 KERZEN, SPEICHERE IM ARRAY
   CopyBuffer(movingAverageDefinition, 0,0,3,SMMAArray);
   
   //BERECHNE MOVING AVERAGE FÜR KERZE 1
   float Value0 = SMMAArray[0];
   //=======================================================================================================================
   
   
   //=======================================================================================================================
   //================================== SIGNAL =============================================================================
   //Long Signal
   if(Value0 > MiddleBand0 && SMMAArray[1] < MiddleBand1 && MacDValue < 0) {
      order("buy");
   }
   
   //Short Signal
   if(Value0 < MiddleBand0 && SMMAArray[1] > MiddleBand1 && MacDValue > 0) {
      order("sell");
   }   
   //=======================================================================================================================
}

void order(string signal) {
    //Get the Bid price
   double Bid = NormalizeDouble(SymbolInfoDouble(_Symbol, SYMBOL_BID), _Digits);
   
   //Get the Ask price
   double Ask = NormalizeDouble(SymbolInfoDouble(_Symbol, SYMBOL_ASK), _Digits);
   
   //Buy 10 Microlot
   if(signal == "buy" && PositionsTotal() < 1) {
      trade.Buy(0.10, NULL, Ask, (Ask-15*_Point), (Ask+15*_Point), NULL);
   }
   
   //Sell 10 Microlot
   if(signal == "sell" && PositionsTotal() < 1){
      trade.Sell(0.10, NULL, Bid, (Bid+15*_Point), (Bid-15*_Point), NULL);
   }
}